#property copyright "Solree & Nord"

extern string time = "00:00";
extern string type = "B";
extern double lot = 0;
extern double stopLoss = 0;
extern double takeProfit = 0;
extern string comment = "";
extern int magic = 0;

bool work;

int init()
{
    work = true;
    
    return;
}

int start()
{
    if (work)
    {
        int hour = TimeHour(StrToTime(time));
        int minute = TimeMinute(StrToTime(time));
        
        if (hour == TimeHour(TimeCurrent()) && minute == TimeMinute(TimeCurrent()))
        {
            work = false;
            
            if (type != "B" && type != "S" && type != "Buy" && type != "Sell")
            {
                Alert("   .  B(Buy)  S(Sell)");
                return;
            }
    
            if (lot <= 0)
            {
                Alert(" .");
                return;
            }
            
            double stop, take;
            int error = 0;

            if (type == "B" || type == "Buy")
            {
                if (stopLoss > 0)
                    stop = Ask-stopLoss;
                    
                if (takeProfit > 0)
                    take = Ask+takeProfit;
            
                while(OrderSend(Symbol(), OP_BUY, NormalizeDouble(lot, 2), NormalizeDouble(Ask, Digits), 0, NormalizeDouble(stop, Digits), NormalizeDouble(take, Digits), comment, magic) == -1)
                {
                    error = GetLastError();
                
                    switch(error)
                    {
                    case 4:
                        Sleep(3000);
                        RefreshRates();
                        
                        if (stopLoss > 0)
                            stop = Ask-stopLoss;
                    
                        if (takeProfit > 0)
                            take = Ask+takeProfit;
                        
                        break;
                        
                    case 130:
                        Alert("TimeOrider:     ");
                        return;
                        
                    default:
                        Alert("TimeOrider:    " + error + ".    http://docs.mql4.com/ru/constants/errors      .");
                        return;
                    }
                }
            }
            else if (type == "S" || type == "Sell")
            {
                if (stopLoss > 0)
                    stop = Bid+stopLoss;
                    
                if (takeProfit > 0)
                    take = Bid-takeProfit;
            
                while(OrderSend(Symbol(), OP_SELL, NormalizeDouble(lot, 2), NormalizeDouble(Bid, Digits), 0, NormalizeDouble(stop, Digits), NormalizeDouble(take, Digits), comment, magic) == -1)
                {
                    error = GetLastError();
                
                    switch(error)
                    {
                    case 4:
                        Sleep(3000);
                        RefreshRates();
                        
                        if (stopLoss > 0)
                            stop = Bid+stopLoss;
                    
                        if (takeProfit > 0)
                            take = Bid-takeProfit;
                        
                        break;
                        
                    case 130:
                        Alert("TimeOrider:     ");
                        return;
                        
                    default:
                        Alert("TimeOrider:    " + error + ".    http://docs.mql4.com/ru/constants/errors      .");
                        return;
                    }
                }
            }
        }
    }
}

